program qpvis;
uses crt;
const order=12;
      CostMagP=4514;
      CostMagN=870;

type list=array[1..order*order] of word;
type quad12=array[1..14,1..14] of word;
     quad15=array[1..17,1..17] of word;
     quad17=array[1..19,1..19] of word;
     quad22=array[1..24,1..24] of word;

const primi:list=(
          1,    3,    5,    7,   11,   13,   17,   19,   23,   29,   31,
         37,   41,   43,   47,   53,   59,   61,   67,   71,   73,   79,
         83,   89,   97,  101,  103,  107,  109,  113,  127,  131,  137,
        139,  149,  151,  157,  163,  167,  173,  179,  181,  191,  193,
        197,  199,  211,  223,  227,  229,  233,  239,  241,  251,  257,
        263,  269,  271,  277,  281,  283,  293,  307,  311,  313,  317,
        331,  337,  347,  349,  353,  359,  367,  373,  379,  383,  389,
        397,  401,  409,  419,  421,  431,  433,  439,  443,  449,  457,
        461,  463,  467,  479,  487,  491,  499,  503,  509,  521,  523,
        541,  547,  557,  563,  569,  571,  577,  587,  593,  599,  601,
        607,  613,  617,  619,  631,  641,  643,  647,  653,  659,  661,
        673,  677,  683,  691,  701,  709,  719,  727,  733,  739,  743,
        751,  757,  761,  769,  773,  787,  797,  809,  811,  821,  823,
        827);

var q12:quad12;
    q15:quad15;
    q17:quad17;
    q22:quad22;
    f:file of byte;
    f12:file of quad12;
    f15:file of quad15;
    f17:file of quad17;
    f22:file of quad22;
    dir,name:string;
    tipo:(_12,_15,_17,_22,_none);
    k:char;

procedure ReadQuad;
var size:longint;
begin
  assign(f,name);
  reset(f);
  size:=filesize(f);
  case size of
   392:begin
         assign(f12,name);
         reset(f12);
         read(f12,q12);
         close(f12);
         tipo:=_12;
       end;
   578:begin
         assign(f15,name);
         reset(f15);
         read(f15,q15);
         close(f15);
         tipo:=_15;
       end;
   722:begin
         assign(f17,name);
         reset(f17);
         read(f17,q17);
         close(f17);
         tipo:=_17;
       end;
   1152:begin
         assign(f22,name);
         reset(f22);
         read(f22,q22);
         close(f22);
         tipo:=_22;
   end;
   else tipo:=_none;
  end;
  close(f);
end;

procedure WriteQuad12(var q:quad12; c:word);
var i,j:byte;
const order=12;
begin
  for i:=1 to order do
   begin
    if q[i,Order+1]=c then TextBackground(15);
    for j:=1 to order do
      begin
        gotoxy(j*4+1,i);
        if odd(j) then TextColor(2)
                  else TextColor(3);
        write(q[i,j]:4);
      end;
    TextBackGround(0);
   end;
  for i:=1 to order do
    begin
      gotoxy((Order+1)*4+1,i);
      if q[i,Order+1]=c then TextColor(3)
                        else TextColor(5);
      write(q[i,Order+1]:8,' ',integer(c-q[i,Order+1]):6);
      gotoxy(i*4+1,Order+1);
      if q[Order+1,i]=c then TextColor(3)
                        else if odd(i) then TextColor(4)
                                       else TextColor(5);
      write(q[Order+1,i]:4);
      gotoxy(i*4+1,Order+2);
      write(integer(c-q[Order+1,i]):4);
    end;
  gotoxy((Order+1)*4+1,Order+1);
  if q[Order+1,Order+1]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+1,Order+1]:8);
  gotoxy((Order+1)*4+1,Order+2);
  write(integer(c-q[Order+1,Order+1]):5);
  gotoxy(1,Order+1);
  if q[Order+2,Order+2]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+2,Order+2]);
  gotoxy(1,Order+2);
  write(integer(c-q[Order+2,Order+2]):5);
end;

procedure WriteQuad15(var q:quad15; c:word);
const order=15;
var i,j:byte;
begin
  for i:=1 to order do
   begin
    if q[i,Order+1]=c then TextBackground(15);
    for j:=1 to order do
      begin
        gotoxy(j*4+1,i);
        if odd(j) then TextColor(2)
                  else TextColor(3);
        write(q[i,j]:4);
      end;
    TextBackGround(0);
   end;
  for i:=1 to order do
    begin
      gotoxy((Order+1)*4+1,i);
      if q[i,Order+1]=c then TextColor(3)
                        else TextColor(5);
      write(q[i,Order+1]:8,' ',integer(c-q[i,Order+1]):6);
      gotoxy(i*4+1,Order+1);
      if q[Order+1,i]=c then TextColor(3)
                        else if odd(i) then TextColor(4)
                                       else TextColor(5);
      write(q[Order+1,i]:4);
      gotoxy(i*4+1,Order+2);
      write(integer(c-q[Order+1,i]):4);
    end;
  gotoxy((Order+1)*4+1,Order+1);
  if q[Order+1,Order+1]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+1,Order+1]:8);
  gotoxy((Order+1)*4+1,Order+2);
  write(integer(c-q[Order+1,Order+1]):5);
  gotoxy(1,Order+1);
  if q[Order+2,Order+2]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+2,Order+2]);
  gotoxy(1,Order+2);
  write(integer(c-q[Order+2,Order+2]):5);
end;

procedure WriteQuad17(var q:quad17; c:word);
const order=17;
var i,j:byte;
begin
  for i:=1 to order do
   begin
    if q[i,Order+1]=c then TextBackground(15);
    for j:=1 to order do
      begin
        gotoxy((j-1)*4+1,i);
        if odd(j) then TextColor(2)
                  else TextColor(3);
        write(q[i,j]:4);
      end;
    TextBackGround(0);
   end;
  for i:=1 to order do
    begin
      gotoxy((Order)*4+1,i);
      if q[i,Order+1]=c then TextColor(3)
                        else TextColor(5);
      write(q[i,Order+1]:4,' ',integer(c-q[i,Order+1]):4);
      gotoxy((i-1)*4+1,Order+1);
      if q[Order+1,i]=c then TextColor(3)
                        else if odd(i) then TextColor(4)
                                       else TextColor(5);
      write(q[Order+1,i]:4);
      gotoxy((i-1)*4+1,Order+2);
      write(integer(c-q[Order+1,i]):4);
    end;
  gotoxy((Order)*4+1,Order+1);
  if q[Order+1,Order+1]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+1,Order+1]:6);
  gotoxy((Order)*4+1,Order+2);
  write(integer(c-q[Order+1,Order+1]):5);
  gotoxy(70,Order+3);
  if q[Order+2,Order+2]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+2,Order+2]);
  gotoxy(70,Order+4);
  write(integer(c-q[Order+2,Order+2]):5);
end;

procedure WriteQuad22(var q:quad22; c:word);
const order=22;
var i,j:byte;
begin
  for i:=1 to order do
   begin
    if q[i,Order+1]=c then TextBackground(15);
    for j:=1 to order do
      begin
        gotoxy((j-1)*3+1,i);
        if odd(j) then TextColor(2)
                  else TextColor(3);
        write(q[i,j]:3);
      end;
    TextBackGround(0);
   end;
  for i:=1 to order do
    begin
      gotoxy((Order)*3+1,i);
      if q[i,Order+1]=c then TextColor(3)
                        else TextColor(5);
      write(q[i,Order+1]:4,' ',integer(c-q[i,Order+1]):4);
      gotoxy((i-1)*3+1,Order+1);
      if q[Order+1,i]=c then TextColor(3)
                        else if odd(i) then TextColor(4)
                                       else TextColor(5);
      write(q[Order+1,i]:4);
      gotoxy((i-1)*3+1,Order+2);
      write(integer(c-q[Order+1,i]):4);
    end;
  gotoxy((Order)*3+1,Order+1);
  if q[Order+1,Order+1]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+1,Order+1]:6);
  gotoxy((Order)*3+1,Order+2);
  write(integer(c-q[Order+1,Order+1]):5);
  gotoxy(75,Order+1);
  if q[Order+2,Order+2]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+2,Order+2]);
  gotoxy(75,Order+2);
  write(integer(c-q[Order+2,Order+2]):5);
end;

procedure WriteQuad;
begin
  case tipo of
   _none:;
   _12:WriteQuad12(q12,4514);
   _15:WriteQuad15(q15,9635);
   _17:WriteQuad17(q17,14691);
   _22:WriteQuad22(q22,34926);
  end;
end;

procedure WriteFile12(var q:quad12);
const order=12;
var f:text;
    i,j:byte;
begin
  assign(f,name);
  rewrite(f);
  writeln(f,'Quadrato magico primo di ordine 12:');
  for i:=1 to Order do
   begin
     for j:=1 to Order do
       write(f,q[i,j]:6);
     writeln(f);
   end;
  close(f);
end;

procedure WriteFile15(var q:quad15);
const order=15;
var f:text;
    i,j:byte;
begin
  assign(f,name);
  rewrite(f);
  writeln(f,'Quadrato magico primo di ordine 15:');
  for i:=1 to Order do
   begin
     for j:=1 to Order do
       write(f,q[i,j]:6);
     writeln(f);
   end;
  close(f);
end;

procedure WriteFile17(var q:quad17);
const order=17;
var f:text;
    i,j:byte;
begin
  assign(f,name);
  rewrite(f);
  writeln(f,'Quadrato magico primo di ordine 17:');
  for i:=1 to Order do
   begin
     for j:=1 to Order do
       write(f,q[i,j]:6);
     writeln(f);
   end;
  close(f);
end;

procedure WriteFile22(var q:quad22);
const order=22;
var f:text;
    i,j:byte;
begin
  assign(f,name);
  rewrite(f);
  writeln(f,'Quadrato magico primo di ordine 22:');
  for i:=1 to Order do
   begin
     for j:=1 to Order do
       write(f,q[i,j]:6);
     writeln(f);
   end;
  close(f);
end;

procedure WriteFile;
begin
  case tipo of
   _none:;
   _12:WriteFile12(q12);
   _15:WriteFile15(q15);
   _17:WriteFile17(q17);
   _22:WriteFile22(q22);
  end;
end;

begin
  clrscr;
  repeat
    gotoxy(1,22);
    writeln('Inserisci nome file');
    readln(name);
    ReadQuad;
    WriteQuad;
    gotoxy(1,25);
    write('Inserisci nome output Text file: ');
    readln(name);
    WriteFile;
    clrscr;
    writeln('Per uscire premere Q, altrimenti prosegue per altro file');
    k:=readkey;
  until upcase(k)='Q';
end.